<?php

//SETTINGS
//check by lang
$check_lang = 1;
//check by referer
$check_referer = 1;
//check useragent
$check_useragent = 1;
//check host 
$check_host = 1;
//check ip form database
$check_ip = 1;
$check_ip_file = dirname(__FILE__).'/bots.txt';
//check ip form regex list
$check_ip_regex = 0;
$check_ip_regex_file = dirname(__FILE__).'/rbots.txt';
//check host 
$check_country = 0;
$check_country_allow = array("US", "RU", "DE");
//create cookie for js check
$check_cookie = 0;
//debug
$debug = 0;

//v1.0 for PandoraBox by TopperHarley
if ($debug) error_reporting(E_ALL); else error_reporting(0);
$bots_list = array("google", "yandex", "rambler", "mail.ru", "msn", "microsoft", "bing", "facebook");
$visitor_type = 1; //1-bot, 2-human
$ip = get_ip();

//checks
if (strpos($ip,":"))
{
	if ($debug) echo "[Cloak:IPv6 - its a bot]";
	$visitor_type = 1;
}
else if ($check_lang && empty($_SERVER['HTTP_ACCEPT_LANGUAGE']))
{
	if ($debug) echo "[Cloak:no lang - its a bot]";
	$visitor_type = 1;
}
else if ($check_referer && empty($_SERVER['HTTP_REFERER']))
{
	if ($debug) echo "[Cloak:no referer - its a bot]";	
	$visitor_type = 1;
}
else if ($check_referer && check_referer_bots($_SERVER['HTTP_REFERER']))
{
	if ($debug) echo "[Cloak:not SE referer({$_SERVER['HTTP_REFERER']}) - its a bot]";	
	$visitor_type = 1;
}
else if ($check_useragent && check_useragent())
{
	if ($debug) echo "[Cloak:its a bot({$_SERVER["HTTP_USER_AGENT"]}) by useragent]";
	$visitor_type = 1;
}
else if ($check_host && check_host())
{
	if ($debug) echo "[Cloak:its a bot by host]";	
	$visitor_type = 1;
}
else if ($check_ip && check_ip())
{
	if ($debug) echo "[Cloak:its a bot by ip list]";		
	$visitor_type = 1;
}
else if ($check_ip_regex && check_ip_regex())
{
	if ($debug) echo "[Cloak:its a bot by regex list]";		
	$visitor_type = 1;
}
else if ($check_country && check_country())
{
	if ($debug) echo "[Cloak:not allowed by country list, consider as a bot]";		
	$visitor_type = 1;
}
else
{	
	if ($debug) echo "[Cloak:its a HUMAN]";
	//set cookie, can be checked later in js
	if ($check_cookie) setcookie('js', 'on');
	$visitor_type = 2;
}

//check from localhost - show as for human
//if($ip == '127.0.0.1') $visitor_type = 2;

function get_ip()
{
	foreach (array('HTTP_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_CF_CONNECTING_IP', 'HTTP_X_FORWARDED', 'HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'REMOTE_ADDR') as $key)
		if (array_key_exists($key, $_SERVER) === true)
			foreach (array_map('trim', explode(',', $_SERVER[$key])) as $ip)
				if (filter_var($ip, FILTER_VALIDATE_IP) !== false)
					return $ip;
	return $_SERVER['REMOTE_ADDR'];
}

function check_host()
{
	global $bots_list, $ip;
	$host = gethostbyaddr($ip);
	//google-proxy-66-249-81-129.google.com - not a bot
	if (stripos($host, "google-proxy") !== false) return false;
	//check every bot in hostname
	foreach($bots_list as $bot)
		if (stripos($host, $bot) !== false)
			return true;
	return false;
}

function check_useragent()
{
	global $bots_list;
	if(!empty($_SERVER["HTTP_USER_AGENT"]))
	{
		$ua = $_SERVER["HTTP_USER_AGENT"];
		//check every bot in useragent
		foreach($bots_list as $bot)
			if (stripos($ua, $bot) !== false)
				return true;
	}
	else
	{
		//no useragent - it's a bot
		return true;
	}
	return false;
}

function check_referer_bots($referer)
{
	//contains https://www.google.com/ | https://yandex.ru/clck/... when visited from SE
	global $bots_list;
	foreach($bots_list as $bot)
		//if visited from SE - its a human
		if (stripos($referer, $bot) !== false)
			return false;
	return true;
}

function check_ip()
{
	global $ip, $check_ip_file;
	$list = file($check_ip_file);
	for ($i = 0; $i < count($list); $i++)
	{
		$list[$i] = trim($list[$i]);
		if (strpos($list[$i], '#') === 0)
			continue;		
		if ($ip == $list[$i]) 
			return true;
		if (strstr($list[$i], '/')) {
			$list_item = explode('/', $list[$i]);
			$list_item_long = ip2long($list_item[0]);
			$mask_long = ip2long($list_item[1]);
			$mask =  long2ip($mask_long) == $list_item[1] ? $mask_long : 0xffffffff << (32 - $list_item[1]);
			$ip_long = ip2long($ip);
			if (($ip_long & $mask) == ($list_item_long & $mask))
				return true;
		}
		if (strstr($list[$i], '-'))
		{  
			$list_item = explode('-', $list[$i]);
			if (ip2long($ip)>=ip2long($list_item[0]) && ip2long($ip)<=ip2long($list_item[1]))
				return true;
		}
	}
	return false;
}

function check_ip_regex()
{
	global $ip, $check_ip_regex_file;
	$list = file($check_ip_regex_file);
	for ($i = 0; $i < count($list); $i++)
	{
		$mask = "/".trim($list[$i])."/";
		if (preg_match($mask, $ip))
			return true;
	}
	return false;
}

function check_country()
{
	global $ip, $check_country_allow;
	//need files: GeoIP.dat, geoip.inc.php 
	//download at: http://pandoraboxx.ru/geoip.zip
	include("geoip.inc.php");
	$gi = geoip_open("GeoIP.dat", GEOIP_STANDARD);
	$cc = geoip_country_code_by_addr($gi, $ip);
	geoip_close($gi);	
	//if allowed cc not found - its a bot
	return !in_array($cc, $check_country_allow);
}

function is_bot()
{
	global $visitor_type;
	return $visitor_type == 1;
}

function is_human()
{
	global $visitor_type;
	return $visitor_type == 2;
}

function clpast($str)	
{
	list($date, $time) = explode(' ', $str);
	list($date1, $date2, $date3) = explode('.', $date);
	list($time1, $time2) = explode(':', $time);
	$time = mktime((int)$time1, (int)$time2, 0, (int)$date2, (int)$date1, (int)$date3);
	return time() >= $time;
}

?>